<template>
  <article>
    <section>
      <p>
        You can either select a dataset, or load a ready-to-use example.
      </p>

      <div class="grid-half my-4">
        <label :class="{ 'config-type': true, selected: configType === 'dataset' }">
          <input
            v-model="configType"
            type="radio"
            class="appearance-none"
            value="dataset"
          >
          Dataset
        </label>

        <label :class="{ 'config-type': true, selected: configType === 'example' }">
          <input
            v-model="configType"
            type="radio"
            class="appearance-none"
            value="example"
          >
          Example
        </label>
      </div>

      <transition
        enter-active-class="animated fadeIn fast"
        leave-active-class="animated fadeOut fast"
        mode="out-in"
      >
        <div
          v-if="configType === 'dataset'"
          key="dataset"
        >
          <div class="flex items-center justify-between">
            <label class="flex items-center">
              <select
                v-model="selectedDataset"
                class="select mr-2"
                @change="isLoadButtonAnimated = true"
              >
                <option
                  v-for="dataset of datasets"
                  :key="dataset.name"
                  :value="dataset"
                >
                  {{ dataset.longName }}
                </option>
              </select>

              <Tooltip>
                Select the dataset to work with.
              </Tooltip>
            </label>
          </div>

          <div
            v-if="selectedDataset"
            class="box my-4 p-4"
            v-html="selectedDataset.description"
          />
        </div>

        <div
          v-else-if="configType === 'example'"
          key="example"
        >
          <div class="flex items-center justify-between">
            <label class="flex items-center">
              <select
                v-model="selectedExample"
                class="select mr-2"
                @change="isLoadButtonAnimated = true"
              >
                <option
                  v-for="example of examples"
                  :key="example.name"
                  :value="example"
                >
                  {{ example.name }}
                </option>
              </select>

              <Tooltip>
                Select an example from the list to discover how the program
                works.
              </Tooltip>
            </label>
          </div>

          <div
            v-if="selectedExample"
            class="box my-4 p-4"
            v-html="selectedExample.description"
          />
        </div>
      </transition>

      <transition
        enter-active-class="animated fadeIn delay"
        appear
      >
        <button
          v-if="configType"
          :class="{ 'big-btn ml-auto': true, 'animated flash moderate': isLoadButtonAnimated }"
          @click="loadData"
          @animationend="isLoadButtonAnimated = false"
        >
          Next
        </button>
      </transition>
    </section>

    <hr class="border-t my-8">

    <section>
      <div class="sm:flex">
        <button
          v-if="userData.length > 0"
          class="btn w-full my-4 sm:w-64 sm:m-0 sm:mr-4"
          @click="loadDataset"
        >
          Reload previous configuration
        </button>

        <label class="btn w-full my-4 sm:w-64 sm:m-0">
          Import configuration file
          <ImportFile
            class="opacity-0 overflow-hidden absolute w-px h-px"
            @load="importSettings(JSON.parse($event))"
          />
        </label>
      </div>
    </section>

    <hr class="border-t my-8">

    <section class="xl:grid-half lg:items-center mb-4">
      <div>
        <p class="algo-description">
          ANCORE uses the DEBuNk algorithm to find patterns showing relative
          behaviour change.
        </p>

        <p class="algo-description">
          A <span class="keyword">pattern</span> is made of
          a <span class="keyword">context</span> (a set of ballots) and
          two <span class="keyword">groups</span> of individuals. We are looking
          for the change of behaviour in this
          <span class="keyword">context</span> between the
          two <span class="keyword">groups</span>.
        </p>

        <p class="algo-description">
          The algorithm takes a <span class="keyword">contexts search
            perimeter</span> and two <span class="keyword">study groups</span>
          of individuals.
        </p>

        <p class="algo-description">
          In our case:
          <ul>
            <li>
              objects are <em>ballots</em>
            </li>

            <li>
              individuals are <em>voters</em>
            </li>

            <li>
              evaluations are their <em>votes</em>
            </li>
          </ul>
        </p>
      </div>

      <img
        class="w-full"
        src="@/assets/platform_schema.svg"
      >
    </section>

    <section class="flex-center flex-col mb-4">
      <template v-if="lang == 'en'">
        <video
          controls
          class="w-full lg:w-2/3"
        >
          <source
            src="https://contentcheck.liris.cnrs.fr/demo_en.webm"
            type="video/webm"
          >
          <source
            src="https://contentcheck.liris.cnrs.fr/demo_en.mp4"
            type="video/mp4"
          >
          <p>
            Your browser doesn't support HTML5 video. Here is
            a <a href="http://contentcheck.liris.cnrs.fr/demo_en.mp4"> link to
              the video </a> instead.
          </p>
        </video>
      </template>

      <template v-else>
        <video
          controls
          class="w-full lg:w-2/3"
        >
          <source
            src="https://contentcheck.liris.cnrs.fr/demo.webm"
            type="video/webm"
          >
          <source
            src="https://contentcheck.liris.cnrs.fr/demo.mp4"
            type="video/mp4"
          >
          <p>
            Your browser doesn't support HTML5 video. Here is
            a <a href="http://contentcheck.liris.cnrs.fr/demo_en.mp4"> link to
              the video </a> instead.
          </p>
        </video>
      </template>

      <div class="mt-4">
        <label>
          <input
            v-model="lang"
            type="radio"
            value="en"
          >
          English
        </label>

        <label>
          <input
            v-model="lang"
            type="radio"
            value="fr"
          >
          French
        </label>
      </div>
    </section>
  </article>
</template>

<style lang="postcss" scoped>
.config-type {
  @apply flex items-center justify-center cursor-pointer p-4 bg-grey-light;

  &.selected, &:hover {
    @apply bg-teal-light;
  }

  &:hover {
    @apply opacity-75;
  }

  transition: all .1s ease-in-out;
}

.delay {
  animation-delay: .25s;
}

.algo-description {
  @apply py-2;
}
</style>

<script lang="ts">
import { Vue, Component, Watch } from 'vue-property-decorator'
import {
  State,
  Getter,
  Action,
  Mutation
} from 'vuex-class'

import _ from 'lodash/fp'

import Tooltip from '@/components/Tooltip.vue'
import ImportFile from '@/components/ImportFile.vue'

import Dataset from '@/types/Dataset'

@Component({
  components: {
    ImportFile,
    Tooltip
  }
})
export default class Home extends Vue {
  @State dataset: Dataset
  @State datasets: Dataset[]
  @State examples: any[]
  @State example: any
  @State userID: string
  @State userData: string
  @State settings: any

  selectedExample = this.example
  selectedDataset = this.dataset
  isLoadButtonAnimated = false
  configType = ''
  lang = 'en'
  showFeedback = false

  loadData () {
    if (this.configType === 'dataset') {
      this.loadDataset()
    } else {
      this.loadExample()
    }
  }

  loadDataset () {
    this.$store.dispatch('fetch_dataset', this.selectedDataset)
      .then(() => {
        this.$router.push('/configuration')
      })
      .catch(() => {
        this.$store.commit('setStatus', {
          message: 'Failed to load dataset.'
        })
      })
  }

  loadExample () {
    this.$store.dispatch('fetch_example', this.selectedExample)
      .then(({ data }) => this.$store.dispatch('import_settings', data))
      .then(() => {
        this.$router.push('/configuration')
      })
      .catch(() => {
        this.$store.commit('setStatus', {
          message: 'Failed to load example.'
        })
      })
  }

  importSettings (data: any) {
    this.$store.dispatch('import_settings', data)
      .then(() => {
        this.$router.push('/configuration')
      })
  }

  @Watch('datasets')
  onDatasetsChanged () {
    this.selectedDataset = this.dataset || _.head(this.datasets)
  }

  @Watch('examples')
  onExamplesChanged () {
    this.selectedExample = this.example || _.head(this.examples)
  }

  mounted () {
    this.selectedDataset = this.dataset || _.head(this.datasets)
    this.selectedExample = this.example || _.head(this.examples)
  }
}
</script>
